list.h File Reference
`#include <gwenhywfar/gwenhywfarapi.h>`
`#include <gwenhywfar/inherit.h>`
`#include <gwenhywfar/refptr.h>`
`#include <string.h>`
`#include <stdio.h>`

Go to the source code of this file.

## Typedefs

typedef struct GWEN_LIST | GWEN_CONSTLIST
| Doubly-linked list with const objects.
typedef const void *(* | GWEN_CONSTLIST_FOREACH_CB) (const void *element, void *user_data)
typedef struct GWEN_LIST_ITERATOR | GWEN_CONSTLIST_ITERATOR
typedef struct GWEN_LIST | GWEN_LIST
| Doubly-linked list.
typedef void *(* | GWEN_LIST_FOREACH_CB) (void *element, void *user_data)
typedef struct GWEN_LIST_ITERATOR | GWEN_LIST_ITERATOR

## Functions

GWENHYWFAR_API void | GWEN_ConstList_Clear (GWEN_CONSTLIST *l)
GWENHYWFAR_API const void * | GWEN_ConstList_Contains (const GWEN_CONSTLIST *l, const void *element)
GWENHYWFAR_API void | GWEN_ConstList_Erase (GWEN_CONSTLIST *l, GWEN_CONSTLIST_ITERATOR *it)
GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * | GWEN_ConstList_FindIter (const GWEN_CONSTLIST *l, const void *element)
GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * | GWEN_ConstList_First (const GWEN_CONSTLIST *l)
GWENHYWFAR_API const void * | GWEN_ConstList_ForEach (GWEN_CONSTLIST *list, GWEN_CONSTLIST_FOREACH_CB func, void *user_data)
GWENHYWFAR_API void | GWEN_ConstList_free (GWEN_CONSTLIST *l)
GWENHYWFAR_API const void * | GWEN_ConstList_GetBack (const GWEN_CONSTLIST *l)
GWENHYWFAR_API const void * | GWEN_ConstList_GetFront (const GWEN_CONSTLIST *l)
GWENHYWFAR_API unsigned int | GWEN_ConstList_GetSize (const GWEN_CONSTLIST *l)
GWENHYWFAR_API int | GWEN_ConstList_IsEmpty (const GWEN_LIST *l)
GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * | GWEN_ConstList_Last (const GWEN_CONSTLIST *l)
GWENHYWFAR_API GWEN_CONSTLIST * | GWEN_ConstList_new (void)
GWENHYWFAR_API void | GWEN_ConstList_PopBack (GWEN_CONSTLIST *l)
GWENHYWFAR_API void | GWEN_ConstList_PopFront (GWEN_CONSTLIST *l)
GWENHYWFAR_API void | GWEN_ConstList_PushBack (GWEN_CONSTLIST *l, const void *p)
GWENHYWFAR_API void | GWEN_ConstList_PushFront (GWEN_CONSTLIST *l, const void *p)
GWENHYWFAR_API void | GWEN_ConstList_Remove (GWEN_CONSTLIST *l, const void *element)
GWENHYWFAR_API const void * | GWEN_ConstListIterator_Data (GWEN_CONSTLIST_ITERATOR *li)
GWENHYWFAR_API void | GWEN_ConstListIterator_free (GWEN_CONSTLIST_ITERATOR *li)
GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * | GWEN_ConstListIterator_new (const GWEN_CONSTLIST *l)
GWENHYWFAR_API const void * | GWEN_ConstListIterator_Next (GWEN_CONSTLIST_ITERATOR *li)
GWENHYWFAR_API const void * | GWEN_ConstListIterator_Previous (GWEN_CONSTLIST_ITERATOR *li)
GWENHYWFAR_API void | GWEN_List_Clear (GWEN_LIST *l)
GWENHYWFAR_API const void * | GWEN_List_Contains (GWEN_LIST *l, const void *element)
GWENHYWFAR_API void | GWEN_List_Dump (const GWEN_LIST *l, FILE *f, unsigned int indent)
GWENHYWFAR_API GWEN_LIST * | GWEN_List_dup (const GWEN_LIST *l)
GWENHYWFAR_API void | GWEN_List_Erase (GWEN_LIST *l, GWEN_LIST_ITERATOR *it)
GWENHYWFAR_API GWEN_LIST_ITERATOR * | GWEN_List_FindIter (GWEN_LIST *l, const void *element)
GWENHYWFAR_API GWEN_LIST_ITERATOR * | GWEN_List_First (const GWEN_LIST *l)
GWENHYWFAR_API void * | GWEN_List_ForEach (GWEN_LIST *list, GWEN_LIST_FOREACH_CB func, void *user_data)
GWENHYWFAR_API void | GWEN_List_free (GWEN_LIST *l)
GWENHYWFAR_API void * | GWEN_List_GetBack (const GWEN_LIST *l)
GWENHYWFAR_API GWEN_REFPTR * | GWEN_List_GetBackRefPtr (const GWEN_LIST *l)
GWENHYWFAR_API void * | GWEN_List_GetFront (const GWEN_LIST *l)
GWENHYWFAR_API GWEN_REFPTR * | GWEN_List_GetFrontRefPtr (const GWEN_LIST *l)
GWENHYWFAR_API GWEN_REFPTR_INFO * | GWEN_List_GetRefPtrInfo (const GWEN_LIST *l)
GWENHYWFAR_API unsigned int | GWEN_List_GetSize (const GWEN_LIST *l)
GWENHYWFAR_API int | GWEN_List_IsEmpty (const GWEN_LIST *l)
GWENHYWFAR_API GWEN_LIST_ITERATOR * | GWEN_List_Last (const GWEN_LIST *l)
GWENHYWFAR_API GWEN_LIST * | GWEN_List_new (void)
GWENHYWFAR_API void | GWEN_List_PopBack (GWEN_LIST *l)
GWENHYWFAR_API void | GWEN_List_PopFront (GWEN_LIST *l)
GWENHYWFAR_API void | GWEN_List_PushBack (GWEN_LIST *l, void *p)
GWENHYWFAR_API void | GWEN_List_PushBackRefPtr (GWEN_LIST *l, GWEN_REFPTR *rp)
GWENHYWFAR_API void | GWEN_List_PushFront (GWEN_LIST *l, void *p)
GWENHYWFAR_API void | GWEN_List_PushFrontRefPtr (GWEN_LIST *l, GWEN_REFPTR *rp)
GWENHYWFAR_API void | GWEN_List_Remove (GWEN_LIST *l, const void *element)
GWENHYWFAR_API void | GWEN_List_SetRefPtrInfo (GWEN_LIST *l, GWEN_REFPTR_INFO *rpi)
GWENHYWFAR_API void | GWEN_List_Unshare (GWEN_LIST *l)
GWENHYWFAR_API void * | GWEN_ListIterator_Data (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API GWEN_REFPTR * | GWEN_ListIterator_DataRefPtr (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API void | GWEN_ListIterator_free (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API unsigned int | GWEN_ListIterator_GetLinkCount (const GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API void | GWEN_ListIterator_IncLinkCount (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API GWEN_LIST_ITERATOR * | GWEN_ListIterator_new (const GWEN_LIST *l)
GWENHYWFAR_API void * | GWEN_ListIterator_Next (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API GWEN_REFPTR * | GWEN_ListIterator_NextRefPtr (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API void * | GWEN_ListIterator_Previous (GWEN_LIST_ITERATOR *li)
GWENHYWFAR_API GWEN_REFPTR * | GWEN_ListIterator_PreviousRefPtr (GWEN_LIST_ITERATOR *li)

## Typedef Documentation

## GWEN_CONSTLIST

typedef struct GWEN_LIST GWEN_CONSTLIST

Doubly-linked list with const objects.

The list contains pointer to const data objects, with the ability to iterate over the list in both directions.

Definition at line 64 of file list.h.

## GWEN_CONSTLIST_FOREACH_CB

typedef const void *(* GWEN_CONSTLIST_FOREACH_CB) (const void *element, void *user_data)

Callback function for one const list element.

Definition at line 67 of file list.h.

## GWEN_CONSTLIST_ITERATOR

typedef struct GWEN_LIST_ITERATOR GWEN_CONSTLIST_ITERATOR

An iterator for the const doubly-linked list, i.e. a pointer to a specific element

Definition at line 76 of file list.h.

## GWEN_LIST

typedef struct GWEN_LIST GWEN_LIST

Doubly-linked list.

The list contains pointer to data objects, with the ability to iterate over the list in both directions.

Definition at line 55 of file list.h.

## GWEN_LIST_FOREACH_CB

typedef void *(* GWEN_LIST_FOREACH_CB) (void *element, void *user_data)

Callback function for one list element.

Definition at line 58 of file list.h.

## GWEN_LIST_ITERATOR

typedef struct GWEN_LIST_ITERATOR GWEN_LIST_ITERATOR

An iterator for the doubly-linked list, i.e. a pointer to a specific element

Definition at line 72 of file list.h.

## Function Documentation

## GWEN_ConstList_Clear()

GWENHYWFAR_API void GWEN_ConstList_Clear | ( | GWEN_CONSTLIST * | l | ) |

Removes all list elements from the list. The elements are not freed.

References GWENHYWFAR_API.

## GWEN_ConstList_Contains()

GWENHYWFAR_API const void * GWEN_ConstList_Contains | ( | const GWEN_CONSTLIST * | l,
|  | const void * | element )

Searches whether the list contains the given element. If it does, the pointer to the element is returned. Otherwise, NULL is returned.

References GWENHYWFAR_API.

## GWEN_ConstList_Erase()

GWENHYWFAR_API void GWEN_ConstList_Erase | ( | GWEN_CONSTLIST * | l,
|  | GWEN_CONSTLIST_ITERATOR * | it )

Removes the element currently pointed to by the given iterator from the list. (The element is not freed.) The given iterator is move toward the next element in any case (if there is no next element then the iterator will point to 0).

References GWENHYWFAR_API.

## GWEN_ConstList_FindIter()

GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * GWEN_ConstList_FindIter | ( | const GWEN_CONSTLIST * | l,
|  | const void * | element )

Finds the LIST_ITERATOR position of the given element. The returned LIST_ITERATOR will be owned by the caller and must be freed when no longer in use. If the list does not contain the element, NULL will be returned.

References GWENHYWFAR_API.

## GWEN_ConstList_First()

GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * GWEN_ConstList_First | ( | const GWEN_CONSTLIST * | l | ) |

Return an iterator pointing to the first element in the list

References GWENHYWFAR_API.

## GWEN_ConstList_ForEach()

GWENHYWFAR_API const void * GWEN_ConstList_ForEach | ( | GWEN_CONSTLIST * | list,
|  | GWEN_CONSTLIST_FOREACH_CB | func,
|  | void * | user_data )

Traverses the list, calling the callback function 'func' on each list element. Traversal will stop when 'func' returns a non-NULL value, and the routine will return with that value. Otherwise the routine will return NULL.

Parameters

  list | The list to traverse.
  func | The function to be called with each list element.
  user_data | A pointer passed on to the function 'func'.

Returns
  The non-NULL pointer returned by 'func' as soon as it returns one. Otherwise (i.e. 'func' always returns NULL) returns NULL.

References GWENHYWFAR_API.

## GWEN_ConstList_free()

GWENHYWFAR_API void GWEN_ConstList_free | ( | GWEN_CONSTLIST * | l | ) |

Destructor. Frees all of the memory used by this list. The list elements are not freed

References GWENHYWFAR_API.

## GWEN_ConstList_GetBack()

GWENHYWFAR_API const void * GWEN_ConstList_GetBack | ( | const GWEN_CONSTLIST * | l | ) |

Returns the last element of the list. (The element is not removed from the list.)

References GWENHYWFAR_API.

## GWEN_ConstList_GetFront()

GWENHYWFAR_API const void * GWEN_ConstList_GetFront | ( | const GWEN_CONSTLIST * | l | ) |

Returns the first element of the list. (The element is not removed from the list.)

References GWENHYWFAR_API.

## GWEN_ConstList_GetSize()

GWENHYWFAR_API unsigned int GWEN_ConstList_GetSize | ( | const GWEN_CONSTLIST * | l | ) |

Returns the size of this list, i.e. the number of elements in this list.

This number is counted in the list metadata, so this is a cheap operation.

References GWENHYWFAR_API.

## GWEN_ConstList_IsEmpty()

GWENHYWFAR_API int GWEN_ConstList_IsEmpty | ( | const GWEN_LIST * | l | ) |

Returns nonzero (TRUE) if this list is empty, and zero (FALSE) if this list is not empty.

References GWENHYWFAR_API.

## GWEN_ConstList_Last()

GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * GWEN_ConstList_Last | ( | const GWEN_CONSTLIST * | l | ) |

Returns an iterator pointing to the last element in the list.

References GWENHYWFAR_API.

## GWEN_ConstList_new()

GWENHYWFAR_API GWEN_CONSTLIST * GWEN_ConstList_new | ( | void |  | ) |

Constructor. Returns a new empty list.

References GWENHYWFAR_API.

## GWEN_ConstList_PopBack()

GWENHYWFAR_API void GWEN_ConstList_PopBack | ( | GWEN_CONSTLIST * | l | ) |

Removes the list's last element from the list. (The element is not freed.)

References GWENHYWFAR_API.

## GWEN_ConstList_PopFront()

GWENHYWFAR_API void GWEN_ConstList_PopFront | ( | GWEN_CONSTLIST * | l | ) |

Removes the list's first element from the list. (The element is not freed.)

References GWENHYWFAR_API.

## GWEN_ConstList_PushBack()

GWENHYWFAR_API void GWEN_ConstList_PushBack | ( | GWEN_CONSTLIST * | l,
|  | const void * | p )

Appends an element to a list, making it the new last element.

References GWENHYWFAR_API.

## GWEN_ConstList_PushFront()

GWENHYWFAR_API void GWEN_ConstList_PushFront | ( | GWEN_CONSTLIST * | l,
|  | const void * | p )

Inserts an element at the start of the list, making it the new first element.

References GWENHYWFAR_API.

## GWEN_ConstList_Remove()

GWENHYWFAR_API void GWEN_ConstList_Remove | ( | GWEN_CONSTLIST * | l,
|  | const void * | element )

Searches for the first occurrence of the "element" pointer and erases that element from the list. (The element itself is not freed.) I.e. this function calls GWEN_List_Erase on the first occurrence found of "element".

References GWENHYWFAR_API.

## GWEN_ConstListIterator_Data()

GWENHYWFAR_API const void * GWEN_ConstListIterator_Data | ( | GWEN_CONSTLIST_ITERATOR * | li | ) |

Returns the pointer to the element stored at the list position the iterator currently points to.

## GWEN_ConstListIterator_free()

GWENHYWFAR_API void GWEN_ConstListIterator_free | ( | GWEN_CONSTLIST_ITERATOR * | li | ) |

Frees a list iterator.

References GWENHYWFAR_API.

## GWEN_ConstListIterator_new()

GWENHYWFAR_API GWEN_CONSTLIST_ITERATOR * GWEN_ConstListIterator_new | ( | const GWEN_CONSTLIST * | l | ) |

Creates a list iterator for the given list.

References GWENHYWFAR_API.

## GWEN_ConstListIterator_Next()

GWENHYWFAR_API const void * GWEN_ConstListIterator_Next | ( | GWEN_CONSTLIST_ITERATOR * | li | ) |

Moves the list iterator to the successor of the currenty selected element and returns that successor element.

References GWENHYWFAR_API.

## GWEN_ConstListIterator_Previous()

GWENHYWFAR_API const void * GWEN_ConstListIterator_Previous | ( | GWEN_CONSTLIST_ITERATOR * | li | ) |

Moves the list iterator to the predecessor of the currenty selected element and returns that predecessor element.

References GWENHYWFAR_API.

## GWEN_List_Clear()

GWENHYWFAR_API void GWEN_List_Clear | ( | GWEN_LIST * | l | ) |

Removes all list elements from the list. The elements are not freed.

References GWENHYWFAR_API.

## GWEN_List_Contains()

GWENHYWFAR_API const void * GWEN_List_Contains | ( | GWEN_LIST * | l,
|  | const void * | element )

Searches whether the list contains the given element. If it does, the pointer to the element is returned. Otherwise, NULL is returned.

References GWENHYWFAR_API.

## GWEN_List_Dump()

GWENHYWFAR_API void GWEN_List_Dump | ( | const GWEN_LIST * | l,
|  | FILE * | f,
|  | unsigned int | indent )

Dumps the contents of the list to an open file (e.g. stderr).

References GWENHYWFAR_API.

## GWEN_List_dup()

GWENHYWFAR_API GWEN_LIST * GWEN_List_dup | ( | const GWEN_LIST * | l | ) |

Duplicates a list by returning a reference and using reference-counting.

References GWENHYWFAR_API.

## GWEN_List_Erase()

GWENHYWFAR_API void GWEN_List_Erase | ( | GWEN_LIST * | l,
|  | GWEN_LIST_ITERATOR * | it )

Removes the element currently pointed to by the given iterator from the list. (The element is not freed.) The given iterator is move toward the next element in any case (if there is no next element then the iterator will point to 0).

References GWENHYWFAR_API.

## GWEN_List_FindIter()

GWENHYWFAR_API GWEN_LIST_ITERATOR * GWEN_List_FindIter | ( | GWEN_LIST * | l,
|  | const void * | element )

Finds the LIST_ITERATOR position of the given element. The returned LIST_ITERATOR will be owned by the caller and must be freed when no longer in use. If the list does not contain the element, NULL will be returned.

References GWENHYWFAR_API.

## GWEN_List_First()

GWENHYWFAR_API GWEN_LIST_ITERATOR * GWEN_List_First | ( | const GWEN_LIST * | l | ) |

Return an iterator pointing to the first element in the list

References GWENHYWFAR_API.

## GWEN_List_ForEach()

GWENHYWFAR_API void * GWEN_List_ForEach | ( | GWEN_LIST * | list,
|  | GWEN_LIST_FOREACH_CB | func,
|  | void * | user_data )

Traverses the list, calling the callback function 'func' on each list element. Traversal will stop when 'func' returns a non-NULL value, and the routine will return with that value. Otherwise the routine will return NULL.

Parameters

  list | The list to traverse.
  func | The function to be called with each list element.
  user_data | A pointer passed on to the function 'func'.

Returns
  The non-NULL pointer returned by 'func' as soon as it returns one. Otherwise (i.e. 'func' always returns NULL) returns NULL.

References GWENHYWFAR_API.

## GWEN_List_free()

GWENHYWFAR_API void GWEN_List_free | ( | GWEN_LIST * | l | ) |

Destructor. Frees all of the memory used by this list. The list elements are not freed.

References GWENHYWFAR_API.

## GWEN_List_GetBack()

GWENHYWFAR_API void * GWEN_List_GetBack | ( | const GWEN_LIST * | l | ) |

Returns the last element of the list. (The element is not removed from the list.)

References GWENHYWFAR_API.

## GWEN_List_GetBackRefPtr()

GWENHYWFAR_API GWEN_REFPTR * GWEN_List_GetBackRefPtr | ( | const GWEN_LIST * | l | ) |

Returns the last element of the list. (The element is not removed from the list.)

References GWENHYWFAR_API.

## GWEN_List_GetFront()

GWENHYWFAR_API void * GWEN_List_GetFront | ( | const GWEN_LIST * | l | ) |

Returns the first element of the list. (The element is not removed from the list.)

References GWENHYWFAR_API.

## GWEN_List_GetFrontRefPtr()

GWENHYWFAR_API GWEN_REFPTR * GWEN_List_GetFrontRefPtr | ( | const GWEN_LIST * | l | ) |

Returns the first element of the list. (The element is not removed from the list.)

References GWENHYWFAR_API.

## GWEN_List_GetRefPtrInfo()

GWENHYWFAR_API GWEN_REFPTR_INFO * GWEN_List_GetRefPtrInfo | ( | const GWEN_LIST * | l | ) |

References GWENHYWFAR_API.

## GWEN_List_GetSize()

GWENHYWFAR_API unsigned int GWEN_List_GetSize | ( | const GWEN_LIST * | l | ) |

Returns the size of this list, i.e. the number of elements in this list.

This number is counted in the list metadata, so this is a cheap operation.

References GWENHYWFAR_API.

## GWEN_List_IsEmpty()

GWENHYWFAR_API int GWEN_List_IsEmpty | ( | const GWEN_LIST * | l | ) |

Returns nonzero (TRUE) if this list is empty, and zero (FALSE) if this list is not empty.

References GWENHYWFAR_API.

## GWEN_List_Last()

GWENHYWFAR_API GWEN_LIST_ITERATOR * GWEN_List_Last | ( | const GWEN_LIST * | l | ) |

Returns an iterator pointing to the last element in the list.

References GWENHYWFAR_API.

## GWEN_List_new()

GWENHYWFAR_API GWEN_LIST * GWEN_List_new | ( | void |  | ) |

allow inheriting of lists Constructor. Returns a new empty list.

References GWENHYWFAR_API.

## GWEN_List_PopBack()

GWENHYWFAR_API void GWEN_List_PopBack | ( | GWEN_LIST * | l | ) |

Removes the list's last element from the list. (The element is not freed.)

References GWENHYWFAR_API.

## GWEN_List_PopFront()

GWENHYWFAR_API void GWEN_List_PopFront | ( | GWEN_LIST * | l | ) |

Removes the list's first element from the list. (The element is not freed.)

References GWENHYWFAR_API.

## GWEN_List_PushBack()

GWENHYWFAR_API void GWEN_List_PushBack | ( | GWEN_LIST * | l,
|  | void * | p )

Appends an element to a list, making it the new last element.

References GWENHYWFAR_API.

## GWEN_List_PushBackRefPtr()

GWENHYWFAR_API void GWEN_List_PushBackRefPtr | ( | GWEN_LIST * | l,
|  | GWEN_REFPTR * | rp )

Appends an element to a list, making it the new last element.

References GWENHYWFAR_API.

## GWEN_List_PushFront()

GWENHYWFAR_API void GWEN_List_PushFront | ( | GWEN_LIST * | l,
|  | void * | p )

Inserts an element at the start of the list, making it the new first element.

References GWENHYWFAR_API.

## GWEN_List_PushFrontRefPtr()

GWENHYWFAR_API void GWEN_List_PushFrontRefPtr | ( | GWEN_LIST * | l,
|  | GWEN_REFPTR * | rp )

Inserts an element at the start of the list, making it the new first element.

References GWENHYWFAR_API.

## GWEN_List_Remove()

GWENHYWFAR_API void GWEN_List_Remove | ( | GWEN_LIST * | l,
|  | const void * | element )

Searches for the first occurrence of the "element" pointer and erases that element from the list. (The element itself is not freed.) I.e. this function calls GWEN_List_Erase on the first occurrence found of "element".

References GWENHYWFAR_API.

## GWEN_List_SetRefPtrInfo()

GWENHYWFAR_API void GWEN_List_SetRefPtrInfo | ( | GWEN_LIST * | l,
|  | GWEN_REFPTR_INFO * | rpi )

References GWENHYWFAR_API.

## GWEN_List_Unshare()

GWENHYWFAR_API void GWEN_List_Unshare | ( | GWEN_LIST * | l | ) |

References GWENHYWFAR_API.

## GWEN_ListIterator_Data()

GWENHYWFAR_API void * GWEN_ListIterator_Data | ( | GWEN_LIST_ITERATOR * | li | ) |

Returns the pointer to the element stored at the list position the iterator currently points to.

References GWENHYWFAR_API.

## GWEN_ListIterator_DataRefPtr()

GWENHYWFAR_API GWEN_REFPTR * GWEN_ListIterator_DataRefPtr | ( | GWEN_LIST_ITERATOR * | li | ) |

Returns the pointer to the element stored at the list position the iterator currently points to.

References GWENHYWFAR_API.

## GWEN_ListIterator_free()

GWENHYWFAR_API void GWEN_ListIterator_free | ( | GWEN_LIST_ITERATOR * | li | ) |

Frees a list iterator.

References GWENHYWFAR_API.

## GWEN_ListIterator_GetLinkCount()

GWENHYWFAR_API unsigned int GWEN_ListIterator_GetLinkCount | ( | const GWEN_LIST_ITERATOR * | li | ) |

References GWENHYWFAR_API.

## GWEN_ListIterator_IncLinkCount()

GWENHYWFAR_API void GWEN_ListIterator_IncLinkCount | ( | GWEN_LIST_ITERATOR * | li | ) |

References GWENHYWFAR_API.

## GWEN_ListIterator_new()

GWENHYWFAR_API GWEN_LIST_ITERATOR * GWEN_ListIterator_new | ( | const GWEN_LIST * | l | ) |

Creates a list iterator for the given list.

References GWENHYWFAR_API.

## GWEN_ListIterator_Next()

GWENHYWFAR_API void * GWEN_ListIterator_Next | ( | GWEN_LIST_ITERATOR * | li | ) |

Moves the list iterator to the successor of the currenty selected element and returns that successor element.

References GWENHYWFAR_API.

## GWEN_ListIterator_NextRefPtr()

GWENHYWFAR_API GWEN_REFPTR * GWEN_ListIterator_NextRefPtr | ( | GWEN_LIST_ITERATOR * | li | ) |

Moves the list iterator to the successor of the currenty selected element and returns that successor element.

References GWENHYWFAR_API.

## GWEN_ListIterator_Previous()

GWENHYWFAR_API void * GWEN_ListIterator_Previous | ( | GWEN_LIST_ITERATOR * | li | ) |

Moves the list iterator to the predecessor of the currenty selected element and returns that predecessor element.

References GWENHYWFAR_API.

## GWEN_ListIterator_PreviousRefPtr()

GWENHYWFAR_API GWEN_REFPTR * GWEN_ListIterator_PreviousRefPtr | ( | GWEN_LIST_ITERATOR * | li | ) |

Moves the list iterator to the predecessor of the currenty selected element and returns that predecessor element.

References GWENHYWFAR_API.